package com.galaxis.manatee.dao;

import com.galaxis.manatee.capsule.util.GalaxisRepository;
import com.galaxis.manatee.entity.chuanyun.data.object.ChuanyunReimbursementDO;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.stereotype.Repository;

import java.util.List;


/**
 * @author zcj
 * @version 0.1
 */
@Repository
public interface ChuanyunReimbursementDao extends GalaxisRepository<ChuanyunReimbursementDO, String> {

    /**
     * 获取没有下发过的报销数据
     *
     * @param erpFlag  下发flag
     * @param pageable 分页
     * @return 列表
     */
    Page<ChuanyunReimbursementDO> findAllByErpFlag(Integer erpFlag, Pageable pageable);

    List<ChuanyunReimbursementDO> findAllByGroupProjectId(String projectId);

    List<ChuanyunReimbursementDO> findAllByGroupProjectIdAndStatusIn(String projectId, List<Integer> status);

    /**
     * 查询项目下用户的报销单
     *
     * @param projectId
     * @param userId
     * @param status
     * @return
     */
    List<ChuanyunReimbursementDO> findAllByGroupProjectIdAndReimburseUserIdAndStatusIn(String projectId, String userId, List<Integer> status);


}
