package com.galaxis.manatee.task;


import com.fasterxml.jackson.core.type.TypeReference;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.galaxis.manatee.entity.chuanyun.data.object.ChuanyunProjectOrganizationStructureDO;
import com.galaxis.manatee.entity.chuanyun.dto.ChuanyunFindAllBizDTO;
import com.galaxis.manatee.entity.chuanyun.dto.ChuanyunFindAllBizReturnData;
import com.galaxis.manatee.entity.chuanyun.dto.Filter;
import com.galaxis.manatee.manager.ChuanYunManager;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

@Service
@Slf4j
public class ProjectOrganizationStructureTask {

    @Autowired
    private ChuanYunManager chuanYunManager;

//    @Autowired
//    private ProjectOrganizationStructureDao projectOrganizationStructureDao;

    /**
     * 存储项目组织架构和工作组数据
     */
    public void syncData() {
        // 查询项目组织架构录入数据
        try {
            List<ChuanyunProjectOrganizationStructureDO> allPos = getAll();
//            projectOrganizationStructureDao.saveAll(allPos);
        } catch (Exception e) {
            e.printStackTrace();
        }

    }

    private List<ChuanyunProjectOrganizationStructureDO> getAll() throws Exception {
        List<ChuanyunProjectOrganizationStructureDO> result = new ArrayList<>();
        var start = 0;
        var totalCount = 0L;
        var flag = true;
        var pageSize = 100;
        while (flag) {
            Filter filter = Filter.instance(start, start + pageSize, true);
            ChuanyunFindAllBizDTO<Object> response = chuanYunManager.findAll(ChuanyunProjectOrganizationStructureDO.SCHEMA_CODE, filter);
            ChuanyunFindAllBizReturnData<Object> returnData = response.getReturnData();
            if (!response.getSuccessful() || returnData == null) {
                flag = false;
                continue;
            }
            totalCount = returnData.getTotalCount();
            if (totalCount >= start + pageSize) {
                start += pageSize;
            } else {
                flag = false;
            }
            List<Object> bizObjectArray = returnData.getBizObjectArray();
            ObjectMapper objectMapper = new ObjectMapper();
            List<ChuanyunProjectOrganizationStructureDO> posList = objectMapper.convertValue(bizObjectArray, new TypeReference<>() {
            });
            result.addAll(posList);
        }
        return result;

    }

}
