package com.galaxis.manatee.Test.buildProjectTest;

import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.core.type.TypeReference;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.galaxis.manatee.entity.chuanyun.data.object.ChuanyunBuildProject;
import com.galaxis.manatee.entity.chuanyun.dto.ChuanyunFindAllBizDTO;
import com.galaxis.manatee.entity.chuanyun.dto.Filter;
import com.galaxis.manatee.manager.ChuanYunManager;
import com.galaxis.manatee.service.WorkGroupService;
import lombok.Data;
import lombok.extern.slf4j.Slf4j;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;

import java.util.List;

@Slf4j
@SpringBootTest
public class BuildProjectTest {

    @Autowired
    private ChuanYunManager chuanYunManager;

    @Autowired
    private WorkGroupService workGroupService;

    @Test
    void test1() {

        //从氚云查询数据
        // 由于存在两条不正常的数据需要排除在外
        List<String> m = List.of("F0000003_2,AS21149");
        var filter = Filter.instance(0, 10, true, Filter.AND, m);
        ChuanyunFindAllBizDTO<Object> chuanyunFindAllResponse = null;
        try {
            chuanyunFindAllResponse = chuanYunManager.findAll(ChuanyunBuildProject.SCHEMA_CODE, filter);
        } catch (JsonProcessingException e) {
            e.printStackTrace();
        }

        //保存
        List<Object> bizObjectArray = chuanyunFindAllResponse.getReturnData().getBizObjectArray();
        ObjectMapper objectMapper = new ObjectMapper();
        List<ChuanyunBuildProject> bpList = objectMapper.convertValue(bizObjectArray, new TypeReference<>() {
        });


    }

    @Test
    void test2() {
//        workGroupService.findAll();

    }


    @Test
    void test3() {

        int start = 525;
        long totalCount = 0L;
        boolean flag = true;
        int pageSize = 25;
        int max = 530;
        while (flag) {
            try {
                //从氚云查询数据
                // 由于存在两条不正常的数据需要排除在外
                List<String> m = List.of("status_2,1");
                var filter = Filter.instance(start, max, true, Filter.AND, m);
                var chuanyunFindAllResponse = chuanYunManager.findAll(ChuanyunBuildProject.SCHEMA_CODE, filter);
                if (chuanyunFindAllResponse.getReturnData() == null || chuanyunFindAllResponse.getReturnData().getBizObjectArray() == null) {
                    flag = false;
                    continue;
                }
                if (chuanyunFindAllResponse.getReturnData().getTotalCount() >= start + pageSize) {
                    start += pageSize;
                } else {
                    flag = false;
                }
                //获取项目总数
                totalCount = chuanyunFindAllResponse.getReturnData().getTotalCount();
                //保存
                List<Object> bizObjectArray = chuanyunFindAllResponse.getReturnData().getBizObjectArray();
                ObjectMapper objectMapper = new ObjectMapper();
                List<ChuanyunBuildProject> bpList = objectMapper.convertValue(bizObjectArray, new TypeReference<>() {
                });

            } catch (Exception e) {
                log.error(e.getMessage());
                e.printStackTrace();
            }

        }


    }

    @Test
    void test4() {

        // 从氚云查询数据
        // 由于存在两条不正常的数据需要排除在外
        List<String> m = List.of("status_2,1");
        var filter = Filter.instance(800, 900, true, Filter.AND, m);
        ChuanyunFindAllBizDTO<Object> chuanyunFindAllResponse = null;
        try {
            chuanyunFindAllResponse = chuanYunManager.findAll(ChuanyunBuildProject.SCHEMA_CODE, filter);
        } catch (JsonProcessingException e) {
            e.printStackTrace();
        }
        if (chuanyunFindAllResponse.getReturnData() == null || chuanyunFindAllResponse.getReturnData().getBizObjectArray() == null) {
            return;
        }
        //保存
        List<Object> bizObjectArray = chuanyunFindAllResponse.getReturnData().getBizObjectArray();
        ObjectMapper objectMapper = new ObjectMapper();
        List<ChuanyunBuildProject> bpList = objectMapper.convertValue(bizObjectArray, new TypeReference<>() {
        });

    }


    @Test
    void syncBuildProjectToSubTable(){
        List<String> m = List.of("F0000016_2,实施");
        var filter = Filter.instance(0, 400, true, Filter.AND, m);
        ChuanyunFindAllBizDTO<Object> chuanyunFindAllResponse = null;
        try {
            chuanyunFindAllResponse = chuanYunManager.findAll(ChuanyunBuildProject.SCHEMA_CODE, filter);
        } catch (JsonProcessingException e) {
            e.printStackTrace();
        }
        if (chuanyunFindAllResponse.getReturnData() == null || chuanyunFindAllResponse.getReturnData().getBizObjectArray() == null) {
            return;
        }
        //保存
        List<Object> bizObjectArray = chuanyunFindAllResponse.getReturnData().getBizObjectArray();
        ObjectMapper objectMapper = new ObjectMapper();
        List<ChuanyunBuildProject> bpList = objectMapper.convertValue(bizObjectArray, new TypeReference<>() {
        });




    }

    @Data
    static class ProjectSubAccount {
        @JsonProperty("F0000102")
        private String projectType;
        @JsonProperty("F0000075")
        private String implProjectName;
        @JsonProperty("F0000001")
        private String implProjectCode;
        @JsonProperty("F0000007")
        private String signingCompany;
        @JsonProperty("F0000008")
        private String customerName;
        @JsonProperty("F0000034")
        private String nameOfOwner;
        @JsonProperty("F0000035")
        private String projectManager;
        @JsonProperty("F0000027")
        private String SalesDirector;
        @JsonProperty("F0000071")
        private Integer systemWarranty;
        @JsonProperty("F0000072")
        private Integer deviceWarranty;

    }

    @Data
    static class SaleToImpl {
        @JsonProperty("F0000102")
        private String SalesProjectCode;


    }


}

