package com.galaxis.manatee.Test.project;

import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.core.type.TypeReference;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.galaxis.manatee.constant.StringConstant;
import com.galaxis.manatee.entity.chuanyun.data.object.ChuanyunGroupProjectDO;
import com.galaxis.manatee.entity.chuanyun.dto.ChuanyunFindAllBizDTO;
import com.galaxis.manatee.entity.chuanyun.dto.ChuanyunFindBizDTO;
import com.galaxis.manatee.entity.chuanyun.dto.ChuanyunSaveDTO;
import com.galaxis.manatee.entity.chuanyun.dto.Filter;
import com.galaxis.manatee.manager.ChuanYunManager;
import lombok.Data;
import lombok.extern.slf4j.Slf4j;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

@Slf4j
@SpringBootTest
public class CleanZhong {

    @Autowired
    private ChuanYunManager chuanYunManager;


    @Test
    public void getData() {
        var objectMapper = new ObjectMapper();
        var start = 0;
        var totalCount = 0L;
        var flag = true;
        var pageSize = 200;

        while (flag) {

            //从氚云查询数据
            var filter = Filter.instance(start, start + pageSize, true);
            ChuanyunFindAllBizDTO<Object> chuanyunFindAllResponse = null;
            try {
                chuanyunFindAllResponse = chuanYunManager.findAll(ChuanyunGroupProjectDO.SCHEMA_CODE, filter);
            } catch (JsonProcessingException e) {
                e.printStackTrace();
            }
            if (chuanyunFindAllResponse.getReturnData() == null) {
                flag = false;
                continue;
            }
            if (chuanyunFindAllResponse.getReturnData().getTotalCount() >= start + pageSize) {
                start += pageSize;
            } else {
                flag = false;
            }


            //转化为POJO
            List<ChuanyunGroupProjectDO> result = objectMapper.convertValue(chuanyunFindAllResponse.getReturnData().getBizObjectArray(), new TypeReference<>() {
            });
            //获取项目总数
            result.forEach(chuanyunGroupProjectDO -> {
                try {
                    String[] projectMemberList = chuanyunGroupProjectDO.getProjectMemberList();
                    if (projectMemberList != null && projectMemberList.length > 0) {
                        boolean b = updateProject(chuanyunGroupProjectDO.getObjectId(), chuanyunGroupProjectDO);
                    }
                } catch (Exception e) {
                    e.printStackTrace();
                }
            });

        }
        log.info("完成");

    }

    /**
     * 查询是否被填写了工时
     */
    private boolean updateProject(String objectId, ChuanyunGroupProjectDO chuanyunGroupProjectDO) throws Exception {
        ObjectMapper objectMapper = new ObjectMapper();
        GroupProjectMemberListUpdateDTO groupProjectMemberListUpdateDTO = new GroupProjectMemberListUpdateDTO(chuanyunGroupProjectDO);
        String[] projectMemberList = groupProjectMemberListUpdateDTO.getProjectMemberList();
        String[] array1 = Arrays.stream(projectMemberList).filter(s -> !s.equals("8bbb21c4-1140-4bfa-8713-6ee50ea34df0")).toArray(String[]::new);
        groupProjectMemberListUpdateDTO.setProjectMemberList(array1);
        StringBuilder memberString = new StringBuilder();
        for (int i = 0; i < chuanyunGroupProjectDO.getProjectMemberList().length; i++) {
            memberString.append(chuanyunGroupProjectDO.getProjectMemberList()[i]).append(StringConstant.SEMICOLON);
        }
        groupProjectMemberListUpdateDTO.setProjectMemberString(memberString.toString());
        String jsonStr = objectMapper.writeValueAsString(groupProjectMemberListUpdateDTO);
        ChuanyunSaveDTO update = chuanYunManager.update(ChuanyunGroupProjectDO.SCHEMA_CODE, objectId, jsonStr);


        return update.getSuccessful();
    }

    @Test
    public void test1() {
        String objectId = "1d324137-c6ce-11ec-8d00-7cd30adfe3be";
        ChuanyunFindBizDTO<Object> objectChuanyunFindBizDTO = chuanYunManager.find(ChuanyunGroupProjectDO.SCHEMA_CODE, objectId);
        Object bizObject = objectChuanyunFindBizDTO.getReturnData().getBizObject();
        ObjectMapper objectMapper = new ObjectMapper();
        ChuanyunGroupProjectDO chuanyunGroupProjectDO = objectMapper.convertValue(bizObject, ChuanyunGroupProjectDO.class);
        try {
            if (null != chuanyunGroupProjectDO.getProjectMemberList()) {
                boolean b = updateProject(objectId, chuanyunGroupProjectDO);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }

    }

    @Data
    static class GroupProjectMemberListUpdateDTO {
        /**
         * 项目组成员（前端传数据用）
         */
        @JsonProperty("F0000034")
        private String[] projectMemberList;

        @JsonProperty("F0000052")
        private String projectMemberString;

        public void add() {
            String[] newProjectMemberList = new String[projectMemberList.length + 1];
            System.arraycopy(projectMemberList, 0, newProjectMemberList, 0, projectMemberList.length);
            projectMemberList = newProjectMemberList;
        }

        public void delete() {
            String[] newProjectMemberList = new String[projectMemberList.length - 1];
            System.arraycopy(projectMemberList, 0, newProjectMemberList, 0, projectMemberList.length - 1);
            projectMemberList = newProjectMemberList;
        }

        public GroupProjectMemberListUpdateDTO(ChuanyunGroupProjectDO chuanyunGroupProjectDO) {
            if (null != chuanyunGroupProjectDO) {
                if (null != chuanyunGroupProjectDO.getProjectMemberList()) {
                    List<String> memberList = new ArrayList<>();
                    chuanyunGroupProjectDO.getProjectMemberObject().forEach(chuanyunObject -> memberList.add(chuanyunObject.getObjectId()));
                    this.projectMemberList = memberList.toArray(new String[0]);
                }
            }
        }
    }
}
